with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;


procedure Proof is
   
   subtype Scalar is Interval;
   --    subtype Scalar is Numeric;
   
   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;
   
   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=60;
   CutOff: constant Natural :=60;
   Ord: constant Integer:=22;
   Folder_Name: String:="60_22/";
   
   
   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;
   
   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;
   
   R,Rd,Rz,Rdz,Rdp1,Rp1,Rp11: Radius ;
   Ro,C0, Lambda,Mu,Eps: Scalar;
   S,Z,RSmS: Taylor;
   
   Name_Z: String:="Data_Files/z_file_60_1";
   Name_S: String:="Data_Files/s_file_60_1";
   
   Name_Extra: String:="Output_Files/";
   Name_L: String:=Name_Extra & Folder_Name & "lambda_file";
   Name_M: String:=Name_Extra & Folder_Name & "mu_file";
   Name_T: String:=Name_Extra & Folder_Name & "t_file";
   Name_E: String:=Name_Extra & Folder_Name & "eps_file";
   Name_Ro: String:=Name_Extra & Folder_Name & "rho_file";
   Name_C0: String:=Name_Extra & Folder_Name & "c0_file";
   Name_Vec: String:=Name_Extra & Folder_Name & "eigenvector_";
   Name_Bound: String:=Name_Extra & Folder_Name & "der_file";
   EV_Name: String:=Name_Extra & Folder_Name & "ev_";
   EVI_Name: String:=Name_Extra & Folder_Name & "evi_";
   Name_Matrix: String:=Name_Extra & Folder_Name & "matrix_file";
   Name_New_Eps: String:=Name_Extra & Folder_Name & "new_eps_file";
   Name_Eq_Const: String:=Name_Extra & Folder_Name & "eq_const_file";
   Name_RSmS: String:=Name_Extra & Folder_Name & "rsms_file";
   Terms: constant Integer:=4;
   F: File_Type;   
begin
   
   --VARIOUS INPUT DATA
   R:=Rep(1.75);               --radius of analiticity for S
   Rd:=Rep(1.6494140625);      --radius for 1st order derivatives of S
   Rz:=Rep( 0.484375 );        --radius for Z
   Rdz:=Rep(0.47998046875);    --radius of 1st order derivatives  of Z
   Rdp1:=Rep(0.469970703125);  
   Rp1:=Rep(0.469970703125);
   Rp11:=Rep(0.449951171875);

	     
   --READING DATA
   Open(F,In_File,Name_L);
   Get(F,Lambda,False);   --value of Lambda read from a file
   Close(F);
   
   Open(F,In_File,Name_M);
   Get(F,Mu,False);       --value of Mu read from a file
   Close(F);
   
   Open(F,In_File,Name_Ro);
   Get(F,Ro,False);     --value of rho, size of the domain where the operator derivative is estimated, read from a file
   Close(F);
   
   Open(F,In_File,Name_C0);
   Get(F,C0,False);     --value of c_0 read from a file
   Close(F);
   
   Open(F,In_File,Name_E);
   Get(F,Eps,False);      --value of Eps=||N[s^*]-s^*|| read from a file
   Close(F);
   
   
   --READING APPROXIMATIONS FOR Z AND S
   New_Line;
   SetZero(Rz,Z);
   Read(Name_Z,Z);
   SetRho(Rz,Z);
   
   New_Line;
   SetZero(R,S);
   Read(Name_S,S);
   SetRho(R,S);
   
   --READING A PRECOMPUTED RSmS=R_{c_0}(S)-S
   New_Line;
   SetZero(R,RSmS);
   Read(Name_RSmS,RSmS,False);
   SetRho(R,RSmS);
   
   
   Proof(Ord,Name_Vec,EV_Name,EVI_Name,Name_Bound,Name_Matrix,Name_New_Eps,Name_Eq_Const,Sup(Eps),Rd,Rdz,Rdp1,Rp1,Rp11,C0,Lambda,Mu,Ro,S,Z,RSmS,True,Terms);
   
   return;
   
end Proof;




