with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;


procedure Proposition is

   subtype Scalar is Interval;
   --   subtype Scalar is Numeric;

   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=60;
   CutOff: constant Natural :=60;
   Ord: constant Integer:=22;
   Folder_Name: String:="60_22_new/";


   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;

   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;

   Gam,Kappa,RP,RH,RB,RT,RPP,C,Nu,DS: Rep;
   Epps,R,Rd,Rz,Rdz,Rdp1,Rp1,Rp11: Radius ;
   Lambda,Mu,LambdaB,Diff1,Diff2,Delt,T: Scalar;
   S,Z,RS: Taylor;
   FF,F1,F2,F3,F4: File_Type;

   Name_Z: String:="Data_Files/z_file_60_1";
   Name_S: String:="Data_Files/s_file_60_1";

   Name_Extra: String:="/home/gaidash/nobackup/Output_Files/";

   Name_L: String:=Name_Extra & Folder_Name & "lambda_file";
   Name_M: String:=Name_Extra & Folder_Name & "mu_file";
   Name_T: String:=Name_Extra & Folder_Name & "t_file";
   Name_E: String:=Name_Extra & Folder_Name & "eps_file";
   Name_Vec: String:=Name_Extra & Folder_Name & "eigenvector_";
   Name_Bound: String:=Name_Extra & Folder_Name & "der_file";
   EV_Name: String:=Name_Extra & Folder_Name & "ev_";
   EVI_Name: String:=Name_Extra & Folder_Name & "evi_";
   Name_Matrix: String:=Name_Extra & Folder_Name & "matrix_file";
   Terms: constant Integer:=4;
   --   Ce: Scalar:=Scal(Rep(-5.97457567167884724E-003));
   --   Ce: Scalar:=Scal(Rep(-5.97457567E-003),Rep(-5.974575645E-003));
   Ce: Scalar:=Scal(Rep(-5.97457567E-003));



begin

   --VARIOUS INPUT DATA
   R:=Rep(1.75);
   Rd:=Rep(1.6494140625);--radius for 1st order derivatives of S
   Rz:=Rep( 0.484375 ); --radius of Z
   Rdz:=Rep(0.47998046875);--radius of 1st order derivatives  of Z
   Rdp1:=Rep(0.469970703125);
   Rp1:=Rep(0.469970703125);
   Rp11:=Rep(0.449951171875);

   New_Line;
   SetZero(Rz,Z);
   Read(Name_Z,Z);
   SetRho(Rz,Z);

   New_Line;
   SetZero(R,S);
   Read(Name_S,S);
   SetRho(R,S);

   ----------------------------------

   Delt:=Scal(Rep(3.0E-12));
   S:=S+Monom( R,0,0, Ball(Zero,MaxAbs(Delt)) );

   New_Line;
   Put("LOOKING FOR Z FOR S WITH A BOUND...");
   Epps:=Rep(1.0E-14);
   FindZ(Epps,Rd,S,Z);
   Put("DONE");

   RS:=S;
   New_Line;
   Put("DOING RG FOR S WITH A BOUND...");
   Epps:=Rep(1.0E-17);
   RG(Epps,Rd,Rdz,Ce,Lambda,Mu,T,RS,Z);
   Put("DONE");

   New_Line;
   Put("Lambda=[");Txt_Put(Current_Output,Inf(Lambda));Put(",");Txt_Put(Current_Output,Sup(Lambda));Put("]");
   New_Line;
   Put("Mu=[");Txt_Put(Current_Output,Inf(Mu));Put(",");Txt_Put(Current_Output,Sup(Mu));Put("]");

   New_Line;
   Put("||S-R[S]||");Txt_Put(Current_Output,MaxAbs(Norm(RS-S)) );
   New_Line;
   Put("T=");
   Txt_Put(Current_Output,MaxAbs(T));

   New_Line;

   RP:=Inf(R*Scal(1.06999969482421880E+000));
   New_Line;
   Put("RP=");Txt_Put(Current_Output,RP);

   New_Line;

   Kappa:=MaxAbs(RP*Lambda*T);
   New_Line;
   Put("Kappa=");Txt_Put(Current_Output,Kappa);

   C:=Rep'Max(MaxAbs(-Log(Scal(One)-Scal(Kappa))/Scal(Kappa)), MaxAbs(Log(Scal(One)+Scal(Kappa))/Scal(Kappa))) ;
   RH:=Inf(RP*Exp(-C*Scal(Kappa)/(Scal(One)-abs(Lambda)   )));

   New_Line;
   Put("Gamma=");Txt_Put(Current_Output,Gam);

   New_Line;
   Put("RH=");Txt_Put(Current_Output,RH);

   New_Line;

   Nu:=MaxAbs(Lambda*(Scal(One)+Scal(Kappa)));
   RT:=Sup(RP*Exp(C*Scal(Kappa)/(Scal(One)-Scal(Nu)   )));
   New_Line;
   Put("Nu=");Txt_Put(Current_Output,Nu);
   New_Line;
   Put("RT=");Txt_Put(Current_Output,RT);

   New_Line;

   LambdaB:=Lambda*(Scal(One)+RP*T);
   Kappa:=MaxAbs(RP*LambdaB*T);
   C:=Rep'Max(MaxAbs(-Log(Scal(One)-Scal(Kappa))/Scal(Kappa)), MaxAbs(Log(Scal(One)+Scal(Kappa))/Scal(Kappa))) ;
   RB:=Sup(RP*Exp(C*Scal(Kappa)/(Scal(One)-abs(LambdaB)  )));
   New_Line;
   Put("RB=");Txt_Put(Current_Output,RB);

   New_Line;

   LambdaB:=Lambda*(Scal(One)+R*T);
   Kappa:=MaxAbs(R*LambdaB*T);
   C:=Rep'Max(MaxAbs(-Log(Scal(One)-Scal(Kappa))/Scal(Kappa)), MaxAbs(Log(Scal(One)+Scal(Kappa))/Scal(Kappa))) ;
   RPP:=Sup(R*Exp(C*Scal(Kappa)/(Scal(One)- abs(LambdaB)  )));
   New_Line;
   Put("RPP=");Txt_Put(Current_Output,RPP);

   New_Line;
   Kappa:=MaxAbs(Two*RP*Lambda*T);
   C:=Rep'Max(MaxAbs(-Log(Scal(One)-Scal(Kappa))/Scal(Kappa)), MaxAbs(Log(Scal(One)+Scal(Kappa))/Scal(Kappa))) ;
   Diff1:=Scal(Rep'Max(MaxAbs(Norm(R,S-Inv(Exp(-C*Scal(Kappa)/(Scal(One)-abs(Lambda)   )))*S )),
                       MaxAbs(Norm(R,S-Inv(Exp(C*Scal(Kappa)/(Scal(One)-abs(Lambda) )))*S ))) );

   SetRho(RP,S);
   DS:=Rep'Max( MaxAbs(Norm(Der1(R,S))) ,  MaxAbs( Norm(Der2(R,S))) );

   Diff2:=Rep'Max(MaxAbs(Exp(-C*Scal(Kappa)/(Scal(One)-abs(Lambda)))-Scal(One) ) ,
                  MaxAbs(Exp(C*Scal(Kappa)/(Scal(One)-abs(Lambda)))-Scal(One) ))*Scal(DS)/Exp(-C*Scal(Kappa)/(Scal(One)-abs(Lambda))) ;

   New_Line;
   Put("Diff=");Txt_Put(Current_Output,MaxAbs(Diff1+Diff2));


   return;

end Proposition;




