with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;


procedure Renorm is

     subtype Scalar is Interval;
--   subtype Scalar is Numeric;

   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=60;
   CutOff: constant Natural :=60;
   Ord: constant Integer:=22;
   Folder_Name: String:="60_22/";


   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;

   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;

   Epsi,R,Rd,Rz,Rdz,Rdp1,Rp1,Rp11: Radius ;
   Lambda,Mu,T,C0: Scalar;
   ZZ,S,Z,RS: Taylor;
   FF,F1,F2,F3,F4: File_Type;

   Name_Z: String:="Data_Files/z_file_60_1";
   Name_S: String:="Data_Files/s_file_60_1";

   Name_L: String:="Output_Files/" & Folder_Name & "lambda_file";
   Name_M: String:="Output_Files/" & Folder_Name & "mu_file";
   Name_T: String:="Output_Files/" & Folder_Name & "t_file";
   Name_E: String:="Output_Files/" & Folder_Name & "eps_file";
   Name_C0: String:="Output_Files/" & Folder_Name & "c0_file";

   Name_Vec: String:="Output_Files/" & Folder_Name & "eigenvector_";
   EV_Name: String:="Output_Files/" & Folder_Name & "ev_";
   EVI_Name: String:="Output_Files/" & Folder_Name & "evi_";
   Name_Bound: String:="Output_Files/" & Folder_Name & "der_file";
   
   
   F: File_Type;
begin
   --VARIOUS INPUT DATA
   R:=Rep(1.75);              --radius of analyticity for S 
   Rd:=Rep(1.6494140625);     --radius for 1st order derivatives of S
   Rz:=Rep( 0.484375 );       --radius of analyticity for Z
   Rdz:=Rep(0.47998046875);   --radius for 1st order derivatives  of Z
   Rdp1:=Rep(0.469970703125);
   Rp1:=Rep(0.469970703125);
   Rp11:=Rep(0.449951171875);

   New_Line;
   SetZero(Rz,Z);
   Read(Name_Z,Z);
   SetRho(Rz,Z);

   New_Line;
   SetZero(R,S);
   Read(Name_S,S);
   SetRho(R,S);
   
   Open(F,In_File,Name_C0);
   Get(F,C0,False);     --value of c_0 read from a file
   Close(F);
   
   S:=S+Monom( R,0,0, Ball(Zero,Rep(0.001) ) );  --a ball of size 0.001 in the appropriate functional space around the fixed point approximation S. Change the size of the ball if needed.  
   RS:=S;
   New_Line;
   Put("LOOKING FOR Z FOR S WITH A BOUND...");
   Epsi:=Rep(1.35E-9);
   FindZ(Epsi,Rd,S,Z);
   Put("DONE");

   ZZ:=Z;
   New_Line;
   Put("DOING RG FOR S WITH A BOUND...");
   RG(Epsi,Rd,Rdz,C0,Lambda,Mu,T,RS,ZZ);
   Put("DONE");

   New_Line;
   Put("Lambda=");Show(Lambda);
   Put("Mu=");Show(Mu);
   Put("T=");Show(T);

   return;

end Renorm;




