with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;


procedure Renorm_Der is
   
   subtype Scalar is Interval;
   --    subtype Scalar is Numeric;
   
   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;
   
   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=60;
   CutOff: constant Natural :=60;
   Ord: constant Integer:=22;
   Folder_Name: String:="60_22/";
   
   
   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;
   
   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;
   
   Epps,R,Rd,Rz,Rdz,Rdp1,Rp1,Rp11: Radius ;
   DT,Eps,Lambda,Mu: Scalar;
   Delt,T: Scalar;
   H,DZ,PsiS1,PsiS2,PsiS,ZZ,S,Z,RS,RSmS: Taylor;
   FF,F1,F2,F3,F4,F5: File_Type;
   
   Name_Z: String:="Data_Files/z_file_60_1";
   Name_S: String:="Data_Files/s_file_60_1";
   
   Name_Extra: String:="Output_Files/";
   Name_L: String:=Name_Extra & Folder_Name & "lambda_file";
   Name_M: String:=Name_Extra & Folder_Name & "mu_file";
   Name_T: String:=Name_Extra & Folder_Name & "t_file";
   Name_E: String:=Name_Extra & Folder_Name & "eps_file";
   Name_Delt: String:=Name_Extra & Folder_Name & "delt_file";
   Name_Vec: String:=Name_Extra & Folder_Name & "eigenvector_";
   Name_Bound: String:=Name_Extra & Folder_Name & "der_file";
   EV_Name: String:=Name_Extra & Folder_Name & "ev_";
   EVI_Name: String:=Name_Extra & Folder_Name & "evi_";
   Name_Matrix: String:=Name_Extra & Folder_Name & "matrix_file";
   Name_New_Eps: String:=Name_Extra & Folder_Name & "new_eps_file";
   Name_Eq_Const: String:=Name_Extra & Folder_Name & "eq_const_file";
   Name_RSmS: String:=Name_Extra & Folder_Name & "rsms_file";
   Terms: constant Integer:=4;
   Ce: Scalar:=Scal(Rep(-5.97457567167884724E-003));
   
begin
   
   --VARIOUS INPUT DATA
   R:=Rep(1.75);
   Rd:=Rep(1.6494140625);--radius for 1st order derivatives of S
   Rz:=Rep( 0.484375 ); --radius of Z
   Rdz:=Rep(0.47998046875);--radius of 1st order derivatives  of Z
   Rdp1:=Rep(0.469970703125);
   Rp1:=Rep(0.469970703125);
   Rp11:=Rep(0.449951171875);
   
   New_Line;
   SetZero(Rz,Z);
   Read(Name_Z,Z);
   SetRho(Rz,Z);
   
   New_Line;
   SetZero(R,S);
   Read(Name_S,S);
   SetRho(R,S);
   
   --Neighborhood
   --------------------
   --THIS DELTA IS FOR R_c_0
   Delt:=Scal(Rep(3.5E-12));
   --THIS DELTA IS FOR R_c, r  in the paper
   --Delt:=Scal(Rep(1.5E-10));
   --Ce:=Ce+Ball(Zero,Sup( Delt/( R*Sqr(Scal(R)) ) ) );
   --Delt:=Scal(Rep(0.000579833984375));
   Epps:=Rep(2.9E-15);
   --------------------
   
   if Terms /= 4 then
      
      RS:=S;
      New_Line;
      Put("LOOKING FOR Z FOR S WITHOUT A BOUND...");
      FindZ(Epps,Rd,S,Z);
      Put("DONE");
      ZZ:=Z;
      
      New_Line;
      Put("DOING RG WITHOUT A BOUND...");
      RG(Epps,Rd,Rdz,Ce,Lambda,Mu,T,RS,ZZ);
      Put("DONE");
      RSmS:=RS-S;
      Write(Name_RSmS,RSmS,False);
      
      return;
      
      Eps:=Norm(R,RSmS);
      New_Line;
      Put("Eps=");Show(Eps);
      New_Line;
      
      S:=S+Monom( R,0,0, Ball(Zero,MaxAbs(Delt)) );
      
      RS:=S;
      New_Line;
      Put("LOOKING FOR Z FOR S WITH A BOUND...");
      Epps:=Rep(6.5E-12);
      FindZ(Epps,Rd,S,Z);
      Put("DONE");
      New_Line;
      Put("|Z|=");Txt_Put(Current_Output,MaxAbs(Norm(Rz,Z)));
      H:=S-Der1(Rd,S)*Monom(R,1,0,Scal(One))-Der2(Rd,S)*Monom(R,0,1,Scal(One));
      DZ:=H;
      DZh(Rd,S,Z,DZ);
      DTh(Rd,Ce,Scal(Zero),S,Z,H,DZ,DT);
      New_Line;
      Put("Bound on excluded spectrum:=");Txt_Put(Current_Output, MaxAbs(Lambda*DT) );
      
      ZZ:=Z;
      New_Line;
      Put("DOING RG FOR S WITH A BOUND...");
      RG(Epps,Rd,Rdz,Ce,Lambda,Mu,T,RS,ZZ);
      Put("DONE");
      
      --------------------------------------------
      PsiS1:= Comp1(Z,Der1(Rd,S))*Der1(Rdz,Z);
      PsiS2:= Comp1(Z,Der1(Rd,S))*Der2(Rdz,Z);
      PsiS2:=PsiS2 +Comp1(Z,Der2(Rd,S));
      PsiS:=Lambda*Inv(Mu)*Comp(Monom(R,1,0,Lambda),Monom(R,0,1,Lambda), PsiS1)*
	Monom(R,2,0,Scal(One))+
	Lambda*Inv(Mu)*Comp(Monom(R,1,0,Lambda),Monom(R,0,1,Lambda),PsiS2)*
	Monom(R,2,0,Scal(One))+
	Scal(Two)*S*Monom(R,0,1,Scal(One));
      
      New_Line;
      Put("A coefficient in the  upper bound on T=");
      Txt_Put(Current_Output,MaxAbs(Inv(Lambda*Norm(R,PsiS))) );
      New_Line;
      Put("||psi_s^*^EKW||=");
      Txt_Put(Current_Output,MaxAbs(Norm(R,PsiS)));
      ------------------------------------------------
      
      New_Line;
      Put("Lambda=");Show(Lambda);
      Put("Mu=");Show(Mu);
      Put("T=");Show(T);
      Put("Eps=");Show(Eps);
      Put("Delt=");Show(Delt);
      
      --   return;
      
      Create(F1,Out_File,Name_L);
      Create(F2,Out_File,Name_M);
      Create(F3,Out_File,Name_T);
      Create(F4,Out_File,Name_E);
      Create(F5,Out_File,Name_Delt);
      Put(F1,Lambda,False);
      Put(F2,Mu,False);
      Put(F3,T,False);
      Put(F4,Eps,False);
      Put(F5,Delt,False);
      Close(F5);
      Close(F4);
      Close(F3);
      Close(F2);
      Close(F1);
      
   end if;
   
   DRG_Data(Ord,Name_Vec,EV_Name,EVI_Name,Name_Bound,Name_Matrix,Name_New_Eps,Name_Eq_Const,Epps,Rd,Rdz,Rdp1,Rp1,Rp11,Ce,Lambda,Mu,Delt,S,Z,RSmS,True,Terms);

   return;

end Renorm_Der;




