with Reps, Intervals;
use Reps, Intervals;

package S_Intervals is

  subtype Interval is Intervals.Interval;

--- basic
  function S_IsNumeric(S: Interval) return Boolean renames IsNumeric;
  function S_IsNumbers(S: Interval) return Boolean renames IsNumbers;
  function S_Err0(S: Interval) return Boolean renames Err0;
  function S_Scal(K: Integer) return Interval renames Scal;
  function S_Scal(R: Rep) return Interval renames Scal;
  function S_Approx(S: Interval) return Rep renames Approx;

--- sets
  procedure S_ModNumbers(S: in out Interval) renames ModNumbers;
  function S_Ball(R: Rep) return Interval renames Ball;
  function S_Ball(R,E: Rep) return Interval renames Ball;
  function S_Ball(S: Interval) return Interval renames Ball;
  function S_Disk(S: Interval) return Interval renames Disk;
  function S_MaxAbs(S: Interval) return Radius renames MaxAbs;
  function S_Scal(R1,R2: Rep) return Interval renames Scal;
  function S_Center(S: Interval) return Interval renames Center;
  function S_Contains(S: Interval; Z: Rep) return Boolean renames Contains;
  procedure S_ResetCenter(S: in out Interval) renames ResetCenter;
  function S_ResetCenter(S: Interval) return Interval renames ResetCenter;
  function S_ResetBall(S: Interval) return Interval renames ResetBall;
  procedure S_Split(S: in Interval; S0,SE: out Interval) renames Split;
  function S_Widen(S: Interval) return Interval renames Widen;
  function S_Union(S1,S2: Interval) return Interval renames Union;

--- order
  function S_Inf(S: Interval) return Rep renames Inf;
  function S_Sup(S: Interval) return Rep renames Sup;
  function S_LT(S1,S2: Interval) return Boolean renames "<";
  function S_LE(S1,S2: Interval) return Boolean renames "<=";
  function S_GT(S1,S2: Interval) return Boolean renames ">";
  function S_GE(S1,S2: Interval) return Boolean renames ">=";
  function S_Min(S1,S2: Interval) return Interval renames Min;
  function S_Max(S1,S2: Interval) return Interval renames Max;

--- ops
  function S_Norm(S: Interval) return Interval renames Norm;
  function S_InfAbs(S: Interval) return Rep renames InfAbs;
  function S_SupAbs(S: Interval) return Rep renames SupAbs;
  function S_Neg(S: Interval) return Interval renames "-";
  function S_Sum(S,T: Interval) return Interval renames "+";
  function S_Diff(S,T: Interval) return Interval renames "-";
  function S_Prod(R: Rep; S: Interval) return Interval renames "*";
  procedure S_ErrMult(R: in Rep; S: in out Interval) renames ErrMult;
  function S_Quot(S: Interval; R: Rep) return Interval renames "/";
  function S_Sqr(S: Interval) return Interval renames Sqr;
  function S_Prod(S,T: Interval) return Interval renames "*";
  procedure S_MultAdd(S1,S2: in Interval; S3: in out Interval) renames MultAdd;
  function S_Inv(S: Interval) return Interval renames Inv;
  function S_Quot(S,T: Interval) return Interval renames "/";
  function S_Pow(S: Interval; I: Integer) return Interval renames "**";

--- fun
  function S_Cosh(S: Interval) return Interval renames Cosh;
  function S_Sinh(S: Interval) return Interval renames Sinh;
  function S_Cos(S: Interval) return Interval renames Cos;
  function S_Sin(S: Interval) return Interval renames Sin;
  function S_Exp(S: Interval) return Interval renames Exp;
  function S_Log(S: Interval) return Interval renames Log;
  function S_Sqrt(S: Interval) return Interval renames Sqrt;
  function S_TruncExp(N: Natural; S: Interval) return Interval renames TruncExp;
  function S_RemExp(N: Natural; S: Interval) return Interval renames RemExp;

end S_Intervals;
