with Reps.IO, Vectors.IO;
use Reps.IO;

package body Taylors.IO is

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO, Numbers_IO;
   package SV_IO is new SV.IO;
   use SV_IO;

   procedure Show(P: in Taylor) is
   begin
      Show(P.C);
   end Show;

   procedure Get(F: in File_Type; P: out Taylor; Decimal: in Boolean := True) is
      R: Radius;
   begin
      Txt_Get(F,R,Decimal);
      SetZero(R,P);
      Get(F,P.C,Decimal);
      --- errors and error estimates
   end Get;

   procedure Put(F: in File_Type; P: in Taylor; Decimal: in Boolean := True) is
   begin
      Txt_Put(F,P.R,Decimal);
      New_Line(F);
      Put(F,P.C,Decimal);
      --- errors and error estimates
   end Put;

   procedure Read(Name: in String; P: out Taylor; Decimal: in Boolean := True) is
      F: File_Type;
   begin
      Put_Line("Reading " & Name & " ...");
      Open(F,In_File,Name);
      Get(F,P,Decimal);
      Close(F);
      Put_Line("Read " & Name);
   end Read;

   procedure Write(Name: in String; P: in Taylor; Decimal: in Boolean := True) is
      F: File_Type;
   begin
      Put_Line("Writing " & Name);
      Create(F,Out_File,Name);
      Put(F,P,Decimal);
      Close(F);
   end Write;

end Taylors.IO;
