with Ada.Text_IO;
use Ada.Text_IO;

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Vectors.IO is

  procedure Show(V: in Vector);
  procedure Get(F: in File_Type; V: out Vector; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; V: in Vector; Decimal: in Boolean := True);

  procedure Show(A: in Matrix);
  procedure Get(F: in File_Type; A: out Matrix; Decimal: in Boolean := True);
  procedure Put(F: in File_Type; A: in Matrix; Decimal: in Boolean := True);

private

  function Width(I: Integer; Base: Positive := 10) return Positive;
  function EffLast(V: Vector) return Integer;
  function EffLast1(A: Matrix) return Integer;
  function EffLast2(A: Matrix; Alast1: Integer) return Integer;

end Vectors.IO;
